# SoilWater-ToolBox

**This package was developped by Joseph Pollacco and Jesús Fernández Gálvez**

The SoilWater-ToolBox software is open source under the **GP-3.0** License and it includes a set of interlinked modules.  The SoilWater-ToolBox ecosystem is led by J.A.P Pollacco from Manaaki Whenua – Landcare Research in New-Zealand and J. Fernández-Gálvez from the University of Granada in Spain. The objectives of the SoilWater-ToolBox are to derive the soil hydraulic parameters by using a wide range of cost-effective methods. To date, the following modules are currently included into the SoilWater-ToolBox:

1. Intergranular Mixing Particle size distribution model: derives unimodal hydraulic parameters by using particle size distribution (Pollacco et al., 2020);
2. General Beerkan Estimation of Soil Transfer parameters method: derives the unimodal hydraulic parameters from single ring infiltration experiments (Fernández-Gálvez et al., 2019);
3. Sorptivity model: novel computation of sorptivity used in the General Beerkan Estimation of Soil Transfer parameters method (Lassabatere et al., 2021);
4. Derive saturated hydraulic conductivity from unimodal and bimodal *θ*(*ψ*) (Pollacco et al., 2017, 2013b);
5. Invert hydraulic parameters from *θ* time series (Pollacco et al. 2021);
6. Derive unique and physical bimodal Kosugi hydraulic parameters from inverse modelling using water retention and/or unsaturated hydraulic conductivity data directly measured in the laboratory or indirectly obtained from inverting *θ* time series (Fernández-Gálvez et al., 2021).

#### **For further reading on the SoilWater-ToolBox**

[SoilWater-ToolBox](https://manaakiwhenua.github.io/SoilWater_ToolBox/)

## REFERENCES

Fernández-Gálvez, J., Pollacco, J.A.P., Lassabatere, L., Angulo-Jaramillo, R., Carrick, S., 2019. A general Beerkan Estimation of Soil Transfer parameters method predicting hydraulic parameters of any unimodal water retention and hydraulic conductivity curves: Application to the Kosugi soil hydraulic model without using particle size distribution data. Advances in Water Resources 129, 118–130. https://doi.org/10.1016/j.advwatres.2019.05.005

Fernández-Gálvez, J., Pollacco,  J.A.P., Lilburne, L., McNeill, S., Carrick, S., Lassabatere, L., Angulo-Jaramillo, R. 2021. Deriving physical and unique bimodal soil Kosugi hydraulic parameters from inverse modelling. Advances in Water Resources. https://doi.org/10.1016/j.advwatres.2021.103933

Lassabatere, L., Peyneau, P.-E., Yilmaz, D., Pollacco, J., Fernández-Gálvez, J., Latorre, B., Moret-Fernández, D., Di Prima, S., Rahmati, M., Stewart, R.D., Abou Najm, M., Hammecker, C., Angulo-Jaramillo, R., 2021. Scaling procedure for straightforward computation of sorptivity. Hydrology and Earth System Sciences Discussions 1–33. https://doi.org/10/gjjxtk

Pollacco, J.A.P., Fernández-Gálvez, J., Carrick, S., 2020. Improved prediction of water retention curves for fine texture soils using an intergranular mixing particle size distribution model. Journal of Hydrology 584, 124597. https://doi.org/10.1016/j.jhydrol.2020.124597

Pollacco, J.A.P., Fernández-Gálvez, J., Carrick, S., McNeill, S., Peltzer, D.A., Belfort, B., Ackerer, P., Lassabatere, L., Angulo-Jaramillo, Zammit, S.C., Rajanayaka C., 2021. HyPix: 1D Richards equation hydrological model in Julia language using multistep optimization scaling for flexible vertical soil discretization. Submitted to Environmental Modelling & Software.

Pollacco, J.A.P., Nasta, P., Ugalde, J.M.S., Angulo-Jaramillo, R., Lassabatere, L., Mohanty, B.P., Romano, N., 2013. Reduction of feasible parameter space of the inverted soil hydraulic parameters sets for Kosugi model. Soil Science SS-S-12-00268.

Pollacco, J.A.P., Webb, T., McNeill, S., Hu, W., Carrick, S., Hewitt, A., Lilburne, L., 2017. Saturated hydraulic conductivity model computed from bimodal water retention curves for a range of New Zealand soils. Hydrol. Earth Syst. Sci. 21, 2725–2737. https://doi.org/10.5194/hess-21-2725-2017
