# AUTHORS

## *Joseph Pollacco*

As a vadose zone hydrological scientist and modeller, my principal role in the Soils and Landscape team at Manaaki Whenua – Landcare Research in New Zealand is to synergise pedology and hydrology. This has led to the development of S-map-Hydro, which provides 3D hydraulic parameters to a wide range of catchment hydrological models. S-map-Hydro is currently being tested and improved in collaboration with other resarch organizations.

## *Jesús Fernández Gálvez*

Professor at the University of Granada in Spain working in the field of  environmental physics and, particularly, on improving knowledge on the unsaturated zone and the lower atmosphere, as well as the interactions at this interface. My research interest lies between soil physics and hydrology, exploring the nexus between soil, water and climate. 

### *Note from the authors*

Deriving hydraulic parameters from laboratory work is expensive. Therefore, with international collaboration we derive hydraulic properties by using cost-effective methods derived from the principles of physics. This has led to the development of a set of novel methodologies, enabling to abstract more information from traditional physical measurements. 

The models we have developed are programmed using the open-source SoilWater-ToolBox software, which facilitates the comparison and combination of different methods of deriving hydraulic parameters, and computes water fluxes by using physically based hydrological models.