## Abstract: 

Efficient simulation of water-flow processes in the vadose zone and deriving effective soil hydrodynamic parameters are crucially important. The 1D mixed form of the Richards equation is solved in the HYdrological PIXel (**HyPix**) model using the [Julia computer language](https://julialang.org/). HyPix uses a novel performant time-stepping scheme, making the Newton-Raphson linearization very efficient. We provide a complete description of the different processes modelling rainfall interception, root water uptake with compensation, soil evaporation, and ponding using a newly developed computation of sorptivity. A novel multistep optimization algorithm is proposed that inverts the hydraulic parameters from time-series soil water content measured at multiple depths. For each simulated soil layer, HyPix simulates five physical hydrodynamic parameters from the bimodal Kosugi’s model (soil retention curve and hydraulic conductivity) using a novel algorithm to reduce the degree of sensitivity of the parameters. The methodology could potentially be used to upscale the Smap-Hydro New Zealand soil hydraulic database in the future. 
